// Code generated by mockery v2.53.0. DO NOT EDIT.

package pipeline

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockUpdater is an autogenerated mock type for the Updater type
type MockUpdater struct {
	mock.Mock
}

// ProcessEvent provides a mock function with given fields: ctx, pipelineID, event
func (_m *MockUpdater) ProcessEvent(ctx context.Context, pipelineID string, event interface{}) (*models.Pipeline, error) {
	ret := _m.Called(ctx, pipelineID, event)

	if len(ret) == 0 {
		panic("no return value specified for ProcessEvent")
	}

	var r0 *models.Pipeline
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string, interface{}) (*models.Pipeline, error)); ok {
		return rf(ctx, pipelineID, event)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string, interface{}) *models.Pipeline); ok {
		r0 = rf(ctx, pipelineID, event)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Pipeline)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string, interface{}) error); ok {
		r1 = rf(ctx, pipelineID, event)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// RegisterEventHandler provides a mock function with given fields: handler
func (_m *MockUpdater) RegisterEventHandler(handler EventHandler) {
	_m.Called(handler)
}

// NewMockUpdater creates a new instance of MockUpdater. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockUpdater(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockUpdater {
	mock := &MockUpdater{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
